## org.opencyc.elf
Class Node

    java.lang.Object
      |
      +--org.opencyc.elf.ELFObject
            |
            +--org.opencyc.elf.Node

Direct Known Subclasses:
  LowestLevelNode

public class Node
extends ELFObject

Provides the Node container for the Elementary Loop Functioning (ELF).

Author:
  Stephen L. Reed

  Copyright 2001 Cycorp, Inc., license is open source GNU LGPL.

  the license

  www.opencyc.org

  OpenCyc at SourceForge

  THIS SOFTWARE AND KNOWLEDGE BASE CONTENT ARE PROVIDED ``AS IS'' AND ANY EXPRESSED OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE OPENCYC ORGANIZATION OR ITS CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE AND KNOWLEDGE BASE CONTENT, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

Field Summary
`protected BehaviorGeneration` `behaviorGeneration` the BehaviorGeneration for this node
`protected java.util.ArrayList` `childNodes` The Child nodes of this node for the task at hand.
`protected static java.util.HashMap` `nodes` the dictionary of nodes by name name --> Node
`protected Node` `parentNode` The parent node of this node for the task at hand.
`protected java.lang.String` `purpose` the purpose description
`protected org.opencyc.elf.sp.SensoryPerception` `sensoryPerception` the SensoryPerception
`protected java.util.ArrayList` `siblingNodes` the list of sibling nodes at this ELF resolution level
`protected org.opencyc.elf.vj.ValueJudgement` `valueJudgement` the ValueJudgement for this node
`protected WorldModel` `worldModel` the World Model for this node

Fields inherited from class org.opencyc.elf.ELFObject
`name`

Constructor Summary
`Node()` Constructs a new Node object.

Method Summary
`BehaviorGeneration` `getBehaviorGeneration()` Gets the BehaviorGeneration for this node
`java.util.ArrayList` `getChildNodes()` Gets the Child nodes of this node for the task at hand
`java.lang.String` `getName()` Gets the unique name of this node
`java.util.HashMap` `getNodes()` Gets the dictionary of nodes by name
`Node` `getParentNode()` Gets the parent node of this node for the task at hand
`java.lang.String` `getPurpose()` Gets the purpose description
`org.opencyc.elf.sp.SensoryPerception` `getSensoryPerception()` Gets the SensoryPerception
`java.util.ArrayList` `getSiblingNodes()` Gets the list of sibling nodes at this ELF resolution level
`org.opencyc.elf.vj.ValueJudgement` `getValueJudgement()` Gets the ValueJudgement for this node
`WorldModel` `getWorldModel()` Gets the World Model for this node
`void` `setBehaviorGeneration(BehaviorGeneration behaviorGeneration)` Sets the BehaviorGeneration for this node
`void` `setChildNodes(java.util.ArrayList childNodes)` Sets the Child nodes of this node for the task at hand
`void` `setName(java.lang.String name)` Sets the unique name of this node
`void` `setNodes(java.util.HashMap nodes)` Sets the dictionary of nodes by name
`void` `setParentNode(Node parentNode)` Sets the parent node of this node for the task at hand
`void` `setPurpose(java.lang.String purpose)` Sets the purpose description
`void` `setSensoryPerception(org.opencyc.elf.sp.SensoryPerception sensoryPerception)` Sets the SensoryPerception
`void` `setSiblingNodes(java.util.ArrayList siblingNodes)` Sets the list of sibling nodes at this ELF resolution level
`void` `setValueJudgement(org.opencyc.elf.vj.ValueJudgement valueJudgement)` Sets the ValueJudgement for this node
`void` `setWorldModel(WorldModel worldModel)` Sets the World Model for this node
`java.lang.String` `toString()` Returns a string representation of this object.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Field Detail

### nodes

    protected static java.util.HashMap nodes

  the dictionary of nodes by name name --> Node

### purpose

    protected java.lang.String purpose

  the purpose description

### worldModel

    protected WorldModel worldModel

  the World Model for this node

### valueJudgement

    protected org.opencyc.elf.vj.ValueJudgement valueJudgement

  the ValueJudgement for this node

### behaviorGeneration

    protected BehaviorGeneration behaviorGeneration

  the BehaviorGeneration for this node

### sensoryPerception

    protected org.opencyc.elf.sp.SensoryPerception sensoryPerception

  the SensoryPerception

### parentNode

    protected Node parentNode

  The parent node of this node for the task at hand. The topmost node has value null for parentNode.

### childNodes

    protected java.util.ArrayList childNodes

  The Child nodes of this node for the task at hand. The lowest level nodes in the hierarchy have null for childNodes;

### siblingNodes

    protected java.util.ArrayList siblingNodes

  the list of sibling nodes at this ELF resolution level

Constructor Detail

### Node

    public Node()

  Constructs a new Node object.

Method Detail

### toString

    public java.lang.String toString()

  Returns a string representation of this object.
  Overrides:
    `toString` in class `ELFObject`
  Returns:
    a string representation of this object

### getNodes

    public java.util.HashMap getNodes()

  Gets the dictionary of nodes by name
  Returns:
    the dictionary of nodes by name

### setNodes

    public void setNodes(java.util.HashMap nodes)

  Sets the dictionary of nodes by name
  Parameters:
    `nodes` - the dictionary of nodes by name

### getName

    public java.lang.String getName()

  Gets the unique name of this node
  Overrides:
    `getName` in class `ELFObject`
  Returns:
    the unique name of this node

### setName

    public void setName(java.lang.String name)

  Sets the unique name of this node
  Overrides:
    `setName` in class `ELFObject`
  Parameters:
    `name` - the unique name of this node

### getPurpose

    public java.lang.String getPurpose()

  Gets the purpose description
  Returns:
    the purpose description

### setPurpose

    public void setPurpose(java.lang.String purpose)

  Sets the purpose description
  Parameters:
    `purpose` - the purpose description

### getWorldModel

    public WorldModel getWorldModel()

  Gets the World Model for this node
  Returns:
    the World Model for this node

### setWorldModel

    public void setWorldModel(WorldModel worldModel)

  Sets the World Model for this node
  Parameters:
    `worldModel` - the World Model for this node

### getValueJudgement

    public org.opencyc.elf.vj.ValueJudgement getValueJudgement()

  Gets the ValueJudgement for this node
  Returns:
    the ValueJudgement for this node

### setValueJudgement

    public void setValueJudgement(org.opencyc.elf.vj.ValueJudgement valueJudgement)

  Sets the ValueJudgement for this node
  Parameters:
    `valueJudgement` - the ValueJudgement for this node

### getBehaviorGeneration

    public BehaviorGeneration getBehaviorGeneration()

  Gets the BehaviorGeneration for this node
  Returns:
    the BehaviorGeneration for this node

### setBehaviorGeneration

    public void setBehaviorGeneration(BehaviorGeneration behaviorGeneration)

  Sets the BehaviorGeneration for this node
  Parameters:
    `behaviorGeneration` - the BehaviorGeneration for this node

### getSensoryPerception

    public org.opencyc.elf.sp.SensoryPerception getSensoryPerception()

  Gets the SensoryPerception
  Returns:
    the SensoryPerception

### setSensoryPerception

    public void setSensoryPerception(org.opencyc.elf.sp.SensoryPerception sensoryPerception)

  Sets the SensoryPerception
  Parameters:
    `sensoryPerception` - the SensoryPerception

### getParentNode

    public Node getParentNode()

  Gets the parent node of this node for the task at hand
  Returns:
    the parent node of this node for the task at hand

### setParentNode

    public void setParentNode(Node parentNode)

  Sets the parent node of this node for the task at hand
  Parameters:
    `parentNode` - the parent node of this node for the task at hand

### getChildNodes

    public java.util.ArrayList getChildNodes()

  Gets the Child nodes of this node for the task at hand
  Returns:
    the Child nodes of this node for the task at hand

### setChildNodes

    public void setChildNodes(java.util.ArrayList childNodes)

  Sets the Child nodes of this node for the task at hand
  Parameters:
    `childNodes` - the Child nodes of this node for the task at hand

### getSiblingNodes

    public java.util.ArrayList getSiblingNodes()

  Gets the list of sibling nodes at this ELF resolution level
  Returns:
    the list of sibling nodes at this ELF resolution level

### setSiblingNodes

    public void setSiblingNodes(java.util.ArrayList siblingNodes)

  Sets the list of sibling nodes at this ELF resolution level
  Parameters:
    `siblingNodes` - the list of sibling nodes at this ELF resolution level